package com.platform.controller;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.AttributeEntity;
import com.platform.entity.Result;
import com.platform.service.AttributeService;
import com.platform.utils.PageUtils;
import com.platform.utils.PageUtilsPlus;
import com.platform.utils.Query;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-17 16:48:17
 */
@RestController
@RequestMapping("attribute")
public class AttributeController {
    @Autowired
    private AttributeService attributeService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")

    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<AttributeEntity> attributeList = attributeService.queryList(query);
        int total = attributeService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(attributeList, total, query.getLimit(), query.getPage());

        return Result.success(PageUtilsPlus.page(attributeList,(long)total,(long)query.getLimit(),(long) query.getPage()));
    }


    /**
     * 查看信息
     */
    @RequestMapping("/info/{id}")

    public Result info(@PathVariable("id") Integer id) {
        AttributeEntity attribute = attributeService.queryObject(id);

        return Result.success( attribute);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")

    public Result save(@RequestBody AttributeEntity attribute) {
        attributeService.save(attribute);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")

    public Result update(@RequestBody AttributeEntity attribute) {
        attributeService.update(attribute);

        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")

    public Result delete(@RequestBody Integer[] ids) {
        attributeService.deleteBatch(ids);

        return Result.success();
    }

    /**
     * 查看所有列表
     */
    @RequestMapping("/queryAll")
    public Result queryAll(@RequestBody Map<String, Object> params) {

        List<AttributeEntity> list = attributeService.queryList(params);

        return Result.success( list);
    }
}
